// 
#include "define.h"

// 
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

//   LCD
#include "text_lcd.h"

//  
#include "buzzer.h"

//  
#include "keyboard.h"


//    
ISR(INT4_vect) {
	//  
	keyboard_updown();
}

//  ,  
ISR(TIMER0_COMP_vect) {
	//    
	buzzer_tick();
}

//  ,  
ISR(TIMER3_OVF_vect) {
	// 
	//int nCounter = TCNT3,
	//	nLimit = OCR3A;
	//   
	buzzer_change_freq();
}

// 
void hello(void) {
	int i;	
	PORTC |= 0b00000000;
	for(i=0; i<4; ++i) {
		_delay_ms(200);
		PORTC |= (1<<i);
	}	
	for(i=0; i<4; ++i) {
		_delay_ms(200);
		PORTC &= ~(1<<i);
	}
	_delay_ms(200);
}

//
int main(void) {
	// 
	char *sMelody = "A:32-C:32-A:32-C:32-";

	// 
    LCD_PORT   	= 0b00000000; //  LCD
	LCD_DDR		= 0b00000000;     
	DDRE		= 0b00001100; //  E
	DDRC   		= 0b00001111; //  C
	DDRB    	= 0b10000000; //  B
	
	//    
	EIMSK = 0x00;
	EICRB = 0b00000010;	//INT4       0
	EIMSK |= 1<<INT4;

	//  
	sei(); 

	//    
	//hello();

	// 
	buzzer_init_timers();

	// 
	while(true) {
		//   
		if(keyboard_is_event()) {			
			//  
			switch(keyboard_get_key()) {
				case KEY_UP:
					//  
					buzzer_play(sMelody, true);
					break;
				case KEY_DOWN:					
					//  
					buzzer_stop(sMelody, true);
					break;
				case KEY_LEFT:					
					break;
				case KEY_RIGHT:	
					break;
				default:
					break;
			}
		} else {
			//  			
		}
	}
}


