#include "text_lcd.h"

//
void lcd_strobe() {
	// 
	LCD_PORT |= _BV(LCD_E_PIN);
	//
	_delay_us(4);
	// 
	LCD_PORT &= ~_BV(LCD_E_PIN);
}

//    
char lcd_read(char bReadBusy) {
	// 
	char cResult;
    //  /    
    if(bReadBusy) {
        LCD_PORT &= ~_BV(LCD_RS_PIN);
	} else {
        LCD_PORT |= _BV(LCD_RS_PIN);
	}
	//
	LCD_PORT |= _BV(LCD_RW_PIN);
	//  
	LCD_DDR = 0b10000111;
	// 
	LCD_PORT |= _BV(LCD_E_PIN);
	//
	_delay_us(2);	
	//  
	cResult = (LCD_PIN << 1)&0b11110000;
	PORTE = cResult;
	// 
	LCD_PORT &= ~_BV(LCD_E_PIN);
	//
	_delay_us(2);
	// 
	LCD_PORT |= _BV(LCD_E_PIN);
	//
	_delay_us(2);	
	//  
	PORTE = PIND;
	cResult |= (LCD_PIN >> 3)&00001111;
	PORTE = (LCD_PORT >> 3);
	// 
	LCD_PORT &= ~_BV(LCD_E_PIN);

	if(cResult & 0b10000000) {
		cResult |= 0b10000000;
	}
	// 
    return cResult;	
}

//    
void lcd_write(char cData) {	
	//
	LCD_PORT &= ~_BV(LCD_RW_PIN);
	//  
	LCD_DDR = 0b11111111;
	//  	
    LCD_PORT &= 0b00000111;
	LCD_PORT |= (cData >> 1) &0b01111000;
	//
	lcd_strobe();
	//  	
    LCD_PORT &= 0b00000111;
	LCD_PORT |= (cData << 3) &0b01111000;
	//
	lcd_strobe();
}

// 
void lcd_command(char cCmd) {
	//  LCD
    while(lcd_read(true) & 0b10000000) {}
	// 
	LCD_PORT &= ~_BV(LCD_RS_PIN);	
	// 
	lcd_write(cCmd);
}

///
void lcd_init(void) {	
	//
	_delay_ms(16);
	//  
	LCD_DDR = 0b01111111;
	// 
	LCD_PORT &= ~_BV(LCD_RW_PIN);
	LCD_PORT &= ~_BV(LCD_RS_PIN);
	// 8 , 2  
	LCD_PORT |= 0b00011000;
	//
	lcd_strobe();
	//
    _delay_ms(35);
	//
	lcd_strobe();
	//
    _delay_us(64);
	//
	lcd_strobe();
	//
    _delay_us(64);
	//
	lcd_strobe();
	//
    _delay_us(64);
	// 4 , 2  
	LCD_PORT = 0b00010000;
	//
	lcd_strobe();
	//
    _delay_us(64);
	// 4 , 2   
	lcd_command(0b00101000);
	//
    _delay_us(64);

	// 
	lcd_command(0b00001000);
    // 
	lcd_command(0b00000001);
	//   
	lcd_command(0b00010100);	       
	//  
    lcd_command(0b00001100);
}


// 
void lcd_gotoxy(char x, char y) {
    if(y==0) {
        lcd_command((1<<7) + x);
	} else {
        lcd_command((1<<7) + 0x40 + x);
	}
}


// 
void lcd_put_s(const char *sString) {		
	//
	int i=0;
	//
	LCD_PORT |= _BV(LCD_RS_PIN);
	//  
	while(sString[i]) {
		lcd_put_c(sString[i++]);
	}
}

// 
void lcd_put_c(char cData) {		
	//  LCD
	while(lcd_read(true) & 0b10000000) {}
	// 
	LCD_PORT |= _BV(LCD_RS_PIN);	
	// 
	lcd_write(cData);
}
